#!/usr/bin/python
#####   Code for getting user input in sEdit   ###############################
### Riley Ellis, 29 December 2009
#
## To-do:
#
## Ideas:
#
## Notes:
#	- This will definitely be changed; probably have an Input base class
#		and use it for all user input windows
#
##############################################################################

from Tkinter import Toplevel, IntVar, Label, Spinbox, Frame, Button, Tk
from sEdit_misc import spin_font as font

class GetSize:	# have this a derived class of Toplevel?
	def __init__(self, master, width, height):
		self.master = master
		if master:
			self.parent = parent = Toplevel(master)
			parent.transient(master)
		else:
			self.parent = parent = Tk()

		self.size = width, height	# initial settings
		self.width = IntVar(value = width)	# the variables that will be changed by user
		self.height = IntVar(value = height)

		Label(parent, text = "Width", font = font).grid(row = 0, column = 1, sticky = 'w')
		Label(parent, text = "Height", font = font).grid(row = 0, column = 2, sticky = 'w')

		Label(parent, text = "Current", font = font).grid(row = 1, column = 0, padx = 8, sticky = 'w')
		Spinbox(parent, width = 5, values = width, font = font, 
			state = "readonly", takefocus = 0).grid(row = 1, column = 1, padx = 8)
		Spinbox(parent, width = 5, values = height, font = font, 
			state = "readonly", takefocus = 0).grid(row = 1, column = 2, padx = 8)

		Label(parent, text = "New", font = font).grid(row = 2, column = 0, padx = 8, sticky = 'w')
		n_width = Spinbox(parent, width = 5, textvariable = self.width, 
			from_ = 8, to = 32, increment = 8, font = font)
		n_width.grid(row = 2, column = 1, padx = 8)

		n_height = Spinbox(parent, width = 5, textvariable = self.height, 
			from_ = 1, to = 32, font = font)
		n_height.grid(row = 2, column = 2, padx = 8)

		bframe = Frame(parent)	# for OK and Cancel buttons
		bframe.grid(row = 3, columnspan = 3)
		Button(bframe, text = "Okay", command = self.okay).pack(side = 'left')
		Button(bframe, text = "Cancel", command = parent.destroy).pack(side = 'left')


	def __call__(self):
		if self.master:
			self.master.wait_window(self.parent)
		else:
			self.parent.mainloop()
		return self.size

	def okay(self, event = 0):
		try:
			width = int(self.width.get())
			if (width % 8) or not(8 <= width <= 32):
				raise ValueError
			height = int(self.height.get())
			if not(1 <= height <= 32):
				raise ValueError
			self.size = (width, height)
			self.parent.destroy()
		except ValueError:
			print "Invalid width or height"
			self.width.set(self.size[0])
			self.height.set(self.size[1])
def get_size(master, width, height):
	return GetSize(master, width, height).__call__()


