#!/usr/bin/python
#####   Miscellaneous/shared functions and variables   #################
### Riley Ellis, 28 December 2009
#
##############################################################################
from Tkinter import Frame


##############################################################################
###  Constants  ##############################################################
bitmapstring = """
#define image_width {0}
#define image_height {1}
static char image_bits[] {{
{2}
}};"""

menu_font = ("TkDefaultFont", 8)	# font of items in top menu
spin_font = ("TkDefaultFont", 11)	# for text in input boxes

SEP = '#a67777'	# color for the separator line
#colors = ['#b2b2b2', 'black']	# [blank, filled]
colors = ['#d9d9d9', 'black']

BOX = 16	# width/height of each box

UR_MAX = 20-1	# max index of ur_ptr
C_STATES = ["disabled", "normal"]	# states for buttons and menus

BINDINGS = ("<Motion>", "<<B1>>", "<<B3>>", "<ButtonRelease>")	# bindings on edit_field

##############################################################################
###  Miscellaneous functions  ################################################
def filler(parent, width = None, height = None, side = 'top', fill = None):
	# Used for adding filler space
	Frame(parent, width = width, height = height).pack(side = side, fill = fill)

def splice(seq, width):	# partitions 'seq' into list of seqs of size 'width'
	return map(lambda i: seq[i*width:(i+1)*width], range(len(seq)/width))

def nbin(byte):	# convert to binary string (e.g. '10010110')
	if type(byte) == str:
		if len(byte) == 1:	# a character
			byte = ord(byte)
		else:	# hex string (e.g. '0xff')
			byte = int(byte, 16)
	return bin(256 + byte)[3:]

def s_sum(arg):	# like built-in 'sum', but takes any type of sequence as argument
	return reduce(lambda i, j: i + j, arg)


def g_coords(row, col):	# returns the coordinates for a box (one of the pixels)
	x, y = 6 + BOX*col, 6 + BOX*row
	return x, y, x + BOX, y + BOX

def focusin(event):	# selects all text in event.widget
	event.widget.select_range(0, 'end')
##############################################################################


